/**
 * @license https://github.com/Intermesh/goui/blob/main/LICENSE MIT License
 * @copyright Copyright 2023 Intermesh BV
 * @author Merijn Schering <mschering@intermesh.nl>
 */
import { TextField } from "./TextField.js";
import { DateTime } from "../../util";
import { Config } from "../Observable";
import { FieldEventMap } from "./Field";
/**
 * Date field
 *
 * @see Form
 */
export declare class DateField extends TextField {
    inputFormat: string;
    outputFormat: string;
    date?: DateTime;
    timefield?: TextField;
    minDate?: DateTime;
    maxDate?: DateTime;
    private readonly picker;
    private readonly pickerButton;
    constructor();
    protected createControl(): HTMLElement | undefined;
    protected validate(): void;
    set value(v: string | undefined);
    get value(): string | undefined;
    private getValueAsDateTime;
}
/**
 * Shorthand function to create {@see DateField}
 *
 * @param config
 */
export declare const datefield: (config?: Config<DateField, FieldEventMap<DateField>>) => DateField;
//# sourceMappingURL=DateField.d.ts.map