/**
 * @license https://github.com/Intermesh/goui/blob/main/LICENSE MIT License
 * @copyright Copyright 2023 Intermesh BV
 * @author Merijn Schering <mschering@intermesh.nl>
 */
import { Field, FieldEventMap } from "./Field.js";
import { Store } from "../../data/index.js";
import { Config } from "../Observable";
/**
 * Select field
 *
 * @see Form
 */
export declare class SelectField extends Field {
    baseCls: string;
    protected input: HTMLSelectElement | undefined;
    options: {
        [key: string]: any;
    }[];
    store?: Store;
    valueField: string;
    textRenderer?: (record: {
        [key: string]: any;
    }) => string;
    protected createControl(): undefined | HTMLElement;
    getInput(): HTMLSelectElement | undefined;
    drawOptions(): void;
    set value(v: string);
    get value(): string;
    set name(name: string);
    get name(): string;
    protected validate(): void;
}
/**
 * Shorthand function to create {@see SelectField}
 *
 * @param config
 */
export declare const select: (config?: Config<SelectField, FieldEventMap<SelectField>>) => SelectField;
//# sourceMappingURL=SelectField.d.ts.map