import { Form, Observable, ObservableListener, WindowEventMap, Window } from "@intermesh/goui";
export interface LoginEventMap<T extends Observable> extends WindowEventMap<T> {
    cancel: () => void;
    login: () => void;
}
export interface Login {
    on<K extends keyof LoginEventMap<Login>>(eventName: K, listener: Partial<LoginEventMap<Login>>[K]): void;
    fire<K extends keyof LoginEventMap<Login>>(eventName: K, ...args: Parameters<LoginEventMap<Login>[K]>): boolean;
    set listeners(listeners: ObservableListener<LoginEventMap<this>>);
}
export declare class Login extends Window {
    private loginForm;
    private otpForm;
    private loginToken;
    private cardContainer;
    private registerForm;
    private forgotPasswordForm;
    constructor();
    private showForgotPassword;
    private showRegisterForm;
    focus(o?: FocusOptions): void;
    login(form: Form): Promise<void>;
    private onLoginSuccess;
}
//# sourceMappingURL=Login.d.ts.map