/**
 * @license https://github.com/Intermesh/goui/blob/main/LICENSE MIT License
 * @copyright Copyright 2023 Intermesh BV
 * @author Merijn Schering <mschering@intermesh.nl>
 */
import { TextField, TextFieldType } from "./TextField.js";
import { Config } from "../Observable";
import { FieldEventMap } from "./Field";
export declare class NumberField extends TextField {
    type: TextFieldType;
    decimals: number;
    min?: number;
    max?: number;
    protected validate(): void;
    set value(v: number | undefined);
    get value(): number | undefined;
    protected createControl(): undefined | HTMLElement;
}
export declare const numberfield: (config?: Config<NumberField, FieldEventMap<NumberField>>) => NumberField;
//# sourceMappingURL=NumberField.d.ts.map