/**
 * @license https://github.com/Intermesh/goui/blob/main/LICENSE MIT License
 * @copyright Copyright 2023 Intermesh BV
 * @author Merijn Schering <mschering@intermesh.nl>
 */
import { Field, FieldEventMap } from "./Field.js";
import { Config } from "../Observable";
type CheckBoxType = 'box' | 'switch' | 'button';
/**
 * Checkbox field
 *
 * @see Form
 */
export declare class CheckboxField extends Field {
    readonly type: CheckBoxType;
    /**
     *
     * @param type Render the checkbox as a checkbox, switch or toggle button
     */
    constructor(type?: CheckBoxType);
    protected input: HTMLInputElement | undefined;
    protected baseCls: string;
    protected applyTitle(): void;
    focus(o?: FocusOptions): void;
    protected createLabel(): void | HTMLElement;
    protected fireChangeOnBlur: boolean;
    protected createControl(): undefined | HTMLElement;
    set readOnly(readOnly: boolean);
    get readOnly(): boolean;
    setInvalid(msg: string): void;
    protected applyInvalidMsg(): void;
    clearInvalid(): void;
    getInput(): HTMLInputElement | undefined;
    set value(v: boolean);
    get value(): boolean;
    set name(name: string);
    get name(): string;
    protected validate(): void;
}
export type CheckboxFieldConfig = Config<CheckboxField, FieldEventMap<CheckboxField>>;
/**
 * Shorthand function to create {@see CheckboxField}
 *
 * @param config
 */
export declare const checkbox: (config?: Config<CheckboxField, FieldEventMap<CheckboxField>>) => CheckboxField;
export {};
//# sourceMappingURL=CheckboxField.d.ts.map